#!/bin/bash

# ================================================================================
# Setup variables

# eksctl
CLUSTER_NAME=iot-accelerator
NODE_COUNT=1
AWS_REGION=eu-west-1
CLUSTER_RAND=`tr -dc A-Za-z0-9 </dev/urandom | head -c 6 ; echo ''`
CLUSTER_NAME=$CLUSTER_NAME-$CLUSTER_RAND


# ================================================================================
# STEP 1: Install required software

# Install eksctl
curl --silent --location "https://github.com/weaveworks/eksctl/releases/latest/download/eksctl_$(uname -s)_amd64.tar.gz" | tar xz -C /tmp
sudo mv /tmp/eksctl /usr/local/bin
eksctl version

# ================================================================================
# STEP 2: Create EKS cluster and node group

echo Copy this cluster name back into the Accelerator configuration setup
echo $CLUSTER_NAME

# Create cluster
nohup eksctl create cluster --name $CLUSTER_NAME --nodes $NODE_COUNT --region $AWS_REGION > eksctl.out &
tail -f eksctl.out

