/*
* Copyright © 2021. TIBCO Software Inc.
* This file is subject to the license terms contained
* in the license file that is distributed with this file.
*/

var Provisioning = require('../webapp/provisioning');
var wsManager = require('../webapp/websocket-manager');
var router = new wsManager.WebSocketRouter();


router.ws('/socket/provisioning/execute', function(ws) {
    function messageCallback(msg) {
        var message = {
            code: 0,
            message: msg
        };
        ws.send(JSON.stringify(message));
    };

    async function process(request) {
        var provisioner = new Provisioning.Provisioner(); 
        provisioner.execute(request, messageCallback)
            .then(function(response){
                var message = {
                    code: 1,
                    response: response
                };
                ws.send(JSON.stringify(message));
                ws.close(1000);
            })
            .catch(function(error){
                var message = {
                    code: 2,
                    error: error
                };
                ws.send(JSON.stringify(message));
                ws.close(1007);
            });
    };

    // On receiving a message
    ws.on('message', function(message) {
        var request = JSON.parse(message);
        process(request);
    });
});
      

module.exports = router;